api_key = "sk-proj-qR8DLASE6KNx1XdHonu0T3BlbkFJ4aWlWrmyc3K8L8aSW2Hc"
-- Параметр, який регулює чи повинен сервіс замінювати назви емодзі на символи емодзі. Приймає значення "true" або "false".
is_replace_emojis = "true"
-- Параметр, який регулює чи повинен сервіс замінювати знаки пунктуації продиктовані словами на відповідні знаки пунктуації. Приймає значення "true" або "false".
is_replace_punctuation_marks = "true"
-- Параметр, який регулює чи повинен сервіс використовувати мінімальну модель для обробки запиту. Приймає значення "true" або "false".
-- Мінімальна модель працює цілком прийнятно, але при цьому швидше і значно дешевше
is_use_mini_model = "true"
-- Параметр, який регулює номер безкоштовної моделі
-- Значення 0 - Chat GPT, а значення 1 - google gemini.
free_model = "1"
-- Параметр, який регулює чи повинен сервіс видаляти крапку в кінці останнього речення. Приймає значення "true" або "false".
Remove_point_at_end_sentence = "true"


require "import"
import "java.io.File"
import "cjson"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"
import "android.content.*"

function hasInternetConnection()
    local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
    local networkInfo = connectivityManager.getActiveNetworkInfo()
    return networkInfo ~= nil and networkInfo.isConnected()
end

function kill()
    if speechRecognizer ~= nil then
        speechRecognizer.destroy()
        speechRecognizer = nil
    end
    return true
end

function startListening()
    if not hasInternetConnection() then
        print("Відсутній доступ до інтернету. Розпізнавання мовлення неможливе.")
        return false
    end

    speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)
    speechListener = RecognitionListener {
        onResults = function(results)
            data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data ~= nil and data.size() > 0 then
                local recognizedText = data.get(0)
                processRecognizedText(recognizedText)
            end
            kill()
        end,
        onError = function()
            kill()
        end
    }

    recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, Locale.getDefault())
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())
    speechRecognizer.startListening(recognizerIntent)
    speechRecognizer.setRecognitionListener(speechListener)

    return true
end

function processRecognizedText(text)
    node = service.getEditText()
    current_text = service.getText(node)
    local query_url = "http://46.254.107.124:12321/ask?message=" .. text .. "&api_key=" .. api_key.."&current_text="..current_text.."&is_replace_emojis="..is_replace_emojis.."&is_replace_punctuation_marks=" .. is_replace_punctuation_marks.."&is_use_mini_model="..is_use_mini_model.."&free_model="..free_model.."&Remove_point_at_end_sentence="..Remove_point_at_end_sentence
    Http.get(query_url, function(status, data)
        if status == 200 then
            cleanedData = cjson.decode(data)["response"]
            task(200, function()
                node = service.getEditText()
                service.setText(node, cleanedData)
            end)
            service.speak(cleanedData)
        else
            print("Помилка")
            print(cjson.decode(data)["detail"])
        end
    end)
end


startListening()
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
if vibrator.hasVibrator() then
    vibrator.vibrate(300)
end

return true